/****************************************************************************
*   
*
*   "CoatiFrame" Release 1.28
*
*   Portions Copyright (c) 2014-2020
*   by Mellspa.
*   All rights reserved.
*   Copyrighted as an unpublished work.
*
****************************************************************************/

// this include file is needed for the framework
#include <mstwymtbase2.h>

// defines the logic of the game
#include <dreikreuze.h>



//! The definition of the context class of the GET scheme which will be connected to the MSCoatiApp.
class MSHTMLKontext_Game_Get : public MSHTMLKontextN
{
protected:
    
  // the game representation as a class member
  MSDreikreuze dreikreuze;
  
  // two function to interact with the game
  void KommandoFeld(string feld);
  void checkwin();
  
  
  // the class handler functions
  void CommandF11(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF12(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF13(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF21(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF22(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF23(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF31(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF32(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF33(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  
  
  
private:
  void CommandNeuStarten(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandGame(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandRunPostScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandRunWidgetScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
public:
  
  //! contructor  
  MSHTMLKontext_Game_Get(MSCoatiApplication2* theapp, const string& coatiid, unsigned int stack_level, map<string,string>& extended_params);
  
  //! destructor  
  virtual ~MSHTMLKontext_Game_Get();
  
};


//! The definition of the context class of the POST scheme which will be connected to the MSCoatiApp.
//! most parts are equally the GET scheme
class MSHTMLKontext_Game_Post : public MSHTMLKontextN
{
protected:
    
  // the game representation as a class member
  MSDreikreuze dreikreuze;
  
  // two function to interact with the game
  void KommandoFeld(string feld);
  void checkwin();
  
  
  // the class handler functions
  void CommandF11(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF12(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF13(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF21(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF22(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF23(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF31(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF32(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandF33(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  
  void CommandNeuStarten(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandGame(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandRunGetScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandRunWidgetScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);

   
public:
  
  //! contructor  
  MSHTMLKontext_Game_Post(MSCoatiApplication2* theapp, const string& coatiid, unsigned int stack_level, map<string,string>& extended_params);
  
  //! destructor  
  virtual ~MSHTMLKontext_Game_Post();
  
};



//! The definition of the context class of the Widget scheme which will be connected to the MSCoatiApp.
class MSHTMLKontext_GameWidget : public MSHTMLKontextN
{
protected:
  
  
  // the game representation as a class member
  MSDreikreuze dreikreuze;
  
   
  
  // the class handler function
  void CommandGame(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandRunGetScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
  void CommandRunPostScheme(MSXHeader& http_ih, MSXResponseHeader& http_oh, string htmlformcommand);
   
public:
  
  // constructor an destructor are formally needed but does not define any extra content for the game.
  
  //! contructor  
  MSHTMLKontext_GameWidget(MSCoatiApplication2* theapp, const string& coatiid, unsigned int stack_level, map<string,string>& extended_params);
  
  //! destructor  
  virtual ~MSHTMLKontext_GameWidget();
  
};






class MSSpielApp : public MSCoatiApplication2
{

public:
  MSSpielApp(MSPersistentAppStorage& appstorage, 
		  string innerappname,
		  vector<MSCoatiInterfaceProps> _mstp, 
		  map<string,string> extended_params);
  virtual ~MSSpielApp();
     
  virtual MSHTMLKontextN* createNewContext(const string& prefix) override;
};
